class Admin::UsersNewInterfaceController <  OrbitMemberController

  helper MemberHelper
  helper OrbitBackendHelper
  
  before_filter :set_attribute,:except => [:index,:show]
  open_for_user :only => [:setting_account, :edit_user_data, :update]
  open_for_visitor :only => [:index, :show]

  def registration_approval
    page_num = params[:page] || 1
    @users = User.approval_pending.page(page_num).per(12).desc("_id").not_guest_and_approved_user
  end

  def approve_registration
    approve_method params[:users_new_interface_id]
    redirect_to admin_users_new_interface_registration_approval_path
  end

  def approve_method(user_id = nil)
    if !user_id.nil?
      user = User.find(user_id)
      user.approved = true
      user.save
      desk = user.desktop 
      desk.theme = DesktopTheme.first.id.to_s
      desk.wallpaper = nil
      desk.save!
    end
  end

  def approve_selected
    users = params[:userids] || []
    users.each do |user|
      approve_method user
    end
    render :json => {"success"=>true,"url"=>admin_users_new_interface_registration_approval_path}
  end

  def delete_selected
    users = params[:userids] || []
    users.each do |user|
      u = User.find(user)
      u.destroy
    end
    render :json => {"success"=>true,"url"=>admin_users_new_interface_registration_approval_path}
  end

  def index
    get_tags
    get_sub_roles

    @roles = Role.excludes('disabled' => true).asc("_id")

    page_num = params[:page] || 1
    @users = []


    @filter = params[:filter]
    @mq = params[:mq]
    @new_filter = params[:new_filter]

    if @filter && params[:clear]
      @filter.delete(params[:type])
    elsif @filter && @new_filter
      if @filter.has_key?(@new_filter[:type]) && @filter[@new_filter[:type]].include?(@new_filter[:id].to_s)
        @filter[@new_filter[:type]].delete(@new_filter[:id].to_s)
      elsif @filter.has_key?(@new_filter[:type])
        @filter[@new_filter[:type]] << @new_filter[:id].to_s
      else
        @filter.merge!({@new_filter[:type] => [@new_filter[:id].to_s]})
      end
    elsif @new_filter
      @filter = {@new_filter[:type] => [@new_filter[:id].to_s]}
    end

    

    if @filter.blank? and @mq.blank?

      render case params[:at]
        when 'summary'
          @users=User.not_guest_user.page(page_num).per(12).desc("_id").includes('avatar')
          "index_summary"
        when 'thumbnail'
          @users=User.not_guest_user.page(page_num).per(36).desc("_id").includes('avatar')
          "index_thumbnail"
        else
          @users=User.not_guest_user.page(page_num).per(10).desc("_id").includes('avatar')
          "index"
      end

    elsif @filter.blank? and !@mq.blank?

      render case params[:at]
        when 'summary'
          @users=User.not_guest_user.any_of({:user_id => /#{@mq}/i}, {:first_name => /#{@mq}/i}, {:last_name => /#{@mq}/i}, {:email => /#{@mq}/i}, {:office_tel => /#{@mq}/i}).desc("_id").includes('avatar')
          "index_summary"
        when 'thumbnail'
          @users=User.not_guest_user.any_of({:user_id => /#{@mq}/i}, {:first_name => /#{@mq}/i}, {:last_name => /#{@mq}/i}, {:email => /#{@mq}/i}, {:office_tel => /#{@mq}/i}).desc("_id").includes('avatar')
          "index_thumbnail"
        else
          @users=User.not_guest_user.any_of({:user_id => /#{@mq}/i}, {:first_name => /#{@mq}/i}, {:last_name => /#{@mq}/i}, {:email => /#{@mq}/i}, {:office_tel => /#{@mq}/i}).desc("_id").includes('avatar')
          "index"
      end

    elsif !@filter.blank? and @mq.blank?

      render case params[:at]
        when 'summary'
          @users=User.not_guest_user.any_in(:role_ids=>@filter['role']).page(page_num).per(12).desc("_id").includes('avatar')
          "index_summary"
        when 'thumbnail'
          @users=User.not_guest_user.any_in(:role_ids=>@filter['role']).page(page_num).per(36).desc("_id").includes('avatar')
          "index_thumbnail"
        else
          @users=User.not_guest_user.any_in(:role_ids=>@filter['role']).page(page_num).per(10).desc("_id").includes('avatar')
          "index"
      end

    end
    
  end
  
  def show
    
    @user = User.find(params[:id])

    @plugins = OrbitApp::Plugin::Registration.all

    @ppname = Array.new
    @plugins.each do |aa|
      @ppname << [aa.sort_number.to_i, [aa.name, aa.app_name, aa.intro_app_name, aa.front_partial_path]]
    end
    @plugin_shows = @ppname.sort.collect {|v| {"name"=>v[1][0],"app_name"=>v[1][1],"intro_app_name"=>v[1][2],"front_partial_path"=>v[1][3]} }


    @profile_data = []
    @teacher_data = []
    @student_data = []
    @staff_data = []

    attribute_values = @user.attribute_values.asc("_id")
    attribute_values.each{|att_val|
      @profile_data.push({:name => att_val.attribute_field.title,:value =>att_val.get_value_by_locale(I18n.locale.to_s)}) if att_val.attribute_field.attribute.key=="profile" rescue false
    }
    

    if(!params[:show_plugin_profile].nil?)
      @right_partial = OrbitApp::Plugin::Registration.find_by_app_name(params[:show_plugin_profile]).profile_partial_path rescue 'plugin_summary'
      @plugin_app_name = OrbitApp::Plugin::Registration.find_by_app_name(params[:show_plugin_profile]).name rescue nil
    else
      @right_partial = "plugin_summary"
      @plugin_app_name = ''
    end

    # @user.attribute_values.each{|att_val|
    #   @teacher_data.push({:name => att_val.attribute_field.title,:value =>att_val[I18n.locale]})
    # }

    # @user.attribute_values.each{|att_val|
    #   @student_data.push({:name => att_val.attribute_field.title,:value =>att_val[I18n.locale]})
    # }

    # @user.attribute_values.each{|att_val|
    #   @staff_data.push({:name => att_val.attribute_field.title,:value =>att_val[I18n.locale]})
    # }

     # [ {:name=> "1",:value =>"Matt"},{:name=> "2",:value =>"Mark"},{:name=> "3",:value =>"Luke"},{:name=> "4",:value =>"John"} ]
    
    get_info_and_roles
  end
  
  def new
    @user = User.new
    # @disable_all_field = true
    @form_index = 0
    get_info_and_roles
  end
  
  def create
    # puts params.to_yaml
    # attribute_values_key = params[:user].has_key?('new_attribute_values') ? 'new_attribute_values' : 'attribute_values'
    # attribute_values = params[:user].delete(attribute_values_key)
    @user = User.new(params["user"])

    @checkuser = User.where(:user_id => params[:user][:user_id]).first

    if !@checkuser.blank?
      flash.now[:error] = t("users.user_id_error")
    end
    
      # attribute_values.to_hash.each{|key,value|
      #   @user.attribute_values.build(value)
      # }
    # @user.rebuild_sub_roles_from_attribute_values!(attribute_values)
    # binding.pry
    @user.skip_confirmation!
    @user.approved = true

    if !flash.now[:error] && @user.save
      desk = @user.desktop 
      desk.theme = DesktopTheme.first.id.to_s
      desk.wallpaper = nil
      desk.save!
      flash[:notice] = t('create.success.user')
      redirect_to :action => :index
    else
      @user.attribute_values = nil
      @form_index = 0
      render :action => :new , :notice => flash.now[:error]   
    end
  end
  
  def temp_edit
    @user = User.find(params[:id])
    @form_index = 0
    get_info_and_roles    
  end

  def edit
    # @disable_all_field = false
    @user = User.find(params[:id])
    @form_index = 0
    get_info_and_roles
  end

  def edit_passwd
    # @disable_all_field = false
    @user = User.find(params[:users_new_interface_id])
    if current_user.id == @user.id
      redirect_to :action => :index
    end
  end

  def edit_privilege
    @user = User.find(params[:users_new_interface_id])
    if current_user.id == @user.id
      redirect_to :action => :index
    end
  end

  def edit_user_data

    if params[:users_new_interface_id].blank?
      redirect_to :action => :index
    else
      @user = User.find(params[:users_new_interface_id])

      if current_user.id != @user.id
        redirect_to :action => :index
      end

      @form_index = 0
      get_info_and_roles
    end
    
  end

  def setting_account

    if params[:users_new_interface_id].blank?
      redirect_to :action => :index
    else
      @user = User.find(params[:users_new_interface_id])
      if current_user.id != @user.id
        redirect_to :action => :index
      end
    end

  end
  
  def update

    @user = User.find(params[:id])

    if params[:edit_type] == 'edit_passwd'

      @checkuser = User.where(:user_id => params[:user][:user_id]).first

      if !@checkuser.blank? &&  @checkuser.id != @user.id
        flash.now[:error] = t("users.user_id_error")
      elsif @user.admin && current_user.id == @user.id
        flash.now[:error] = t("users.admin_change_password")
      end

      if !flash.now[:error] && @user.update_attributes(params[:user])
        redirect_to :action => :show
      else
        render :action => :edit_passwd, :notice => flash.now[:error]
      end

    elsif params[:edit_type] == 'edit_user_data'

      if current_user.id != @user.id
        redirect_to :action => :index
      end

      @user.update_attributes(params[:user])

      attribute_values_key = params[:user].has_key?('new_attribute_values') ? 'new_attribute_values' : 'attribute_values'

      attribute_values = params[:user].delete(attribute_values_key)
      @user.save

      redirect_to :action => :show

    elsif params[:edit_type] == 'setting_account'

      if current_user.id != @user.id
        redirect_to :action => :index
      end

      if !@user.valid_password?(params[:old_password])
        flash.now[:error] = t("users.valid_old_password")
      end

      if !flash.now[:error] && @user.update_attributes(params[:user])
        redirect_to :action => :show
      else
        render :action => :setting_account, :notice => flash.now[:error]
      end

    elsif params[:edit_type] == 'edit_privilege'

      if @user.admin && current_user.id == @user.id
        flash.now[:error] = t("users.admin_change_password")
      end

      if !flash.now[:error] && @user.update_attributes(params[:user])
        redirect_to :action => :show
      else
        render :action => :edit_privilege, :notice => flash.now[:error]
      end

    else

      @user.update_attributes(params[:user])

      attribute_values_key = params[:user].has_key?('new_attribute_values') ? 'new_attribute_values' : 'attribute_values'
      attribute_values = params[:user].delete(attribute_values_key)
      # @user.rebuild_sub_roles_from_attribute_values!(attribute_values)
      @user.save

      redirect_to :action => :show

    end
    
    
    # # Update changes to the avatar
    # @user.remove_avatar! if params[:file]
    # @user.avatar = params[:file] if params[:file]
    
    # if @user.id.to_s.eql?(session['warden.user.user.key'][1].to_s) && @user.admin != params[:user][:admin].to_i.to_b
    #   flash.now[:error] = t(:cant_revoke_self_admin)
    # end
    # if !flash[:error] && @user.update_attributes(params[:user])
    #   flash[:notice] = t('update.success.user')
    #   redirect_to :action => :index
    # else
    #   get_info_and_roles
    #   render :action => :edit
    # end
  end
  
  def destroy
    if params[:id].eql?(session['warden.user.user.key'][1].to_s)
      flash[:error] = t(:cant_delete_self)
    else
      @user = User.find(params[:id]) 
      @not_approved_count = nil
      if !@user.approved
        @not_approved_count = User.not_guest_and_approved_user.count - 1
      end

      @user.destroy
    end
    
    # redirect_to :action => :index
    respond_to do |format|
      format.html { redirect_to(admin_users_new_interface_index_url(:at=>params[:at])) }
      # format.xml  { head :ok }
      format.js
    end

  end

  def edit_order_card
    @users = User.not_guest_user
    @type = 'card'
    render 'edit_order'
  end

  def edit_order_list
    @users = User.not_guest_user
    @type = 'list'
    render 'edit_order'
  end

  def update_order_card
    @error = false
    if params[:users].present?
      to_go = params[:users][:position].to_i
      user_at_position = User.where(position: to_go).first
      user = User.find(params[:users][:id])
      if user_at_position
        if user.position > user_at_position.position
          user.move_above(user_at_position)
        else
          user.move_below(user_at_position)
        end
      end
    end
    render nothing: true, status: 200
  end

  def update_order_list
    @error = []
    if params[:users].present?
      params[:users].values.sort.each do |pair|
        to_go = pair[0].to_i
        if to_go > 0
          user_at_position = User.where(position: to_go - 1).first
          user = User.find(pair[1])
          if user_at_position && !(user_at_position == user)
            if user.position > user_at_position.position
              user.move_above(user_at_position)
            else
              user.move_below(user_at_position)
            end
          elsif to_go > User.count
            user.move_to_bottom
          end
        end
      end
    end
    @users = User.not_guest_user
  end


  
  protected
  def get_tags
    @sub_role_tags = SubRoleTag.all
  end

  def get_sub_roles
    @sub_roles = SubRole.all
  end

  def get_info_and_roles
    @infos = Info.excludes('disabled' => true)
    @roles = Role.excludes('disabled' => true)
  end

  def set_attribute
    @class = 'users'
  end
  
end
